Bug 1484192 - There are lots of memory leaks in magick/command.c of GraphicsMagick.
Summary: There are lots of memory leaks in magick/command.c of GraphicsMagick.
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: GraphicsMagick
Version: 28
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Andreas Thienemann
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-08-23 01:39 UTC by owl337
Modified: 2019-05-28 19:31 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-05-28 19:31:43 UTC


Attachments (Terms of Use)
Triggered by " ./gm montage POC2 /dev/null " (400 bytes, application/x-rar)
2017-08-23 01:39 UTC, owl337
no flags Details

Description owl337 2017-08-23 01:39:32 UTC
Created attachment 1316924 [details]
Triggered by " ./gm  montage POC2 /dev/null "

Description of problem:

There are lots of memory leaks in magick/command.c of GraphicsMagick

Version-Release number of selected component (if applicable):

<= latest version 

How reproducible:

 ./gm  montage POC2 /dev/null 

Steps to Reproduce:

Description:

The ASAN debugging information is as follows:

$ ./gm  montage POC2 /dev/null  
=================================================================
==64315==ERROR: LeakSanitizer: detected memory leaks

Direct leak of 8216 byte(s) in 1 object(s) allocated from:
    #0 0x4d4a82  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x4d4a82)
    #1 0x626d4a  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x626d4a)
    #2 0x56a5ed  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x56a5ed)
    #3 0x5586e4  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x5586e4)
    #4 0x58a8b1  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x58a8b1)
    #5 0x589619  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x589619)
    #6 0x7f5780b9aabf  (/lib/x86_64-linux-gnu/libc.so.6+0x20abf)

Direct leak of 2160 byte(s) in 1 object(s) allocated from:
    #0 0x4d4a82  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x4d4a82)
    #1 0x626d4a  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x626d4a)
    #2 0x5586e4  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x5586e4)
    #3 0x58a8b1  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x58a8b1)
    #4 0x589619  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x589619)
    #5 0x7f5780b9aabf  (/lib/x86_64-linux-gnu/libc.so.6+0x20abf)

Indirect leak of 512 byte(s) in 2 object(s) allocated from:
    #0 0x4d4a82  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x4d4a82)
    #1 0x626d4a  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x626d4a)
    #2 0x5586e4  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x5586e4)
    #3 0x58a8b1  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x58a8b1)
    #4 0x589619  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x589619)
    #5 0x7f5780b9aabf  (/lib/x86_64-linux-gnu/libc.so.6+0x20abf)

Indirect leak of 100 byte(s) in 3 object(s) allocated from:
    #0 0x4d4a82  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x4d4a82)
    #1 0x626d4a  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x626d4a)
    #2 0x56a5ed  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x56a5ed)
    #3 0x5586e4  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x5586e4)
    #4 0x58a8b1  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x58a8b1)
    #5 0x589619  (/home/icy/secreal/GraphicsMagick-1.3.26-asan/install/bin/gm+0x589619)
    #6 0x7f5780b9aabf  (/lib/x86_64-linux-gnu/libc.so.6+0x20abf)

SUMMARY: AddressSanitizer: 10988 byte(s) leaked in 7 allocation(s).

The vulnerability was triggered in function:
GMCommand (argc=<optimized out>, argv=<optimized out>) at magick/command.c:17455
...
17451	  else
17452	    {
17453	      status = BatchCommand(argc, argv);
17454	    }
17455	  return(!status);
17456	}
...


Actual results:

crash

Expected results:

crash

Additional info:

Credits:

This vulnerability is detected by team OWL337, with our custom fuzzer collAFL. Please contact ganshuitao@gmail.com   and chaoz@tsinghua.edu.cn if you need more info about the team, the tool or the vulnerability.

Comment 1 Fedora End Of Life 2018-02-20 15:27:22 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 28 development cycle.
Changing version to '28'.

Comment 2 Ben Cotton 2019-05-02 22:05:54 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 3 Ben Cotton 2019-05-28 19:31:43 UTC
Fedora 28 changed to end-of-life (EOL) status on 2019-05-28. Fedora 28 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.